package initialize

import (
	"go.etcd.io/bbolt"
	"go.uber.org/zap"
	"gitea.pena/PenaSide/feedback/internal/repository"
)

type Repositories struct {
	Feedback *repository.FeedbackRepository
}

func NewRepositories(logger *zap.Logger, db *bbolt.DB) (*Repositories, error) {
	feedback := repository.NewFeedback(logger, db)
	if err := feedback.CreateBucket(); err != nil {
		return nil, err
	}

	return &Repositories{Feedback: feedback}, nil
}
