package models

import "time"

type Feedback struct {
	Host      string // Хост отправки
	Contact   string
	WhoAmi    string
	CreatedAt time.Time // Время создания
}

// GetID - возвращает идентификатор. Идентификатором является время форматированное в time.StampNano
func (f *Feedback) GetID() string {
	return f.CreatedAt.Format(time.StampNano)
}

type ReqFeedback struct {
	Contact string `json:"contact" validate:"required"`
	WhoAmi  string `json:"whoAmi" validate:"required"`
}

func NewFeedback(host string, contact string, whoAmi string) *Feedback {
	return &Feedback{Host: host, Contact: contact, WhoAmi: whoAmi, CreatedAt: time.Now()}
}
